
#ifndef SETUP_H
#define SETUP_H

#include "common/common.h"


/******************************************************************************
 * Configuration bas niveau pour le fonctionnement et l'efficacite de l'agent *
 ******************************************************************************/

//#define DEBUG
#define CONTAINER_TEST

#define LINUX
//#define EBK // explicit BellMan Kalaba Degugging!
//#define TIMING
//#define TIME1 // computeRBW
//#define TIME2 // DBaddLSP
//#define TIME3 // ComputeBackup
//#define TIME4 // ComputePrimary

//#define AGENT
#define SIMULATOR

#define NB_PREEMPTION           1
#define NB_OA                   1


#define DIGIT_PRECISION           0.0000000001   

#ifndef CONTAINER_TEST // Standard functional values  

#define LSPLIST_INITSIZE          10
#define LSPREQLIST_INITSIZE       10

#define NODEVEC_INITSIZE          100
#define LSPVEC_INITSIZE           100
#define LINKTAB_INITSIZE          100

#define ERROR_PROVISION           5
#define ERRORLIST_INITSIZE        100
#define ERRORMSG_SIZE             200

#define LONGVEC_INITSIZE          10
#define DBLVEC_INITSIZE           10

#define BKCONNECTVEC_INITSIZE     10
#define BKNODEVEC_INITSIZE        50


#else // Values used for debugging (lots of resize) 

#define LSPLIST_INITSIZE          1
#define LSPREQLIST_INITSIZE       1

#define NODEVEC_INITSIZE          1
#define LSPVEC_INITSIZE           1
#define LINKTAB_INITSIZE          1

#define ERROR_PROVISION           5
#define ERRORLIST_INITSIZE        1
#define ERRORMSG_SIZE           200

#define LONGVEC_INITSIZE          1
#define DBLVEC_INITSIZE           1

#define BKCONNECTVEC_INITSIZE     1
#define BKNODEVEC_INITSIZE        1

#endif

/****************************************************************
 * Configuration initiale et en run-time des modules de l'agent *
 ****************************************************************/

double COST;

typedef struct PrimaryComputationConfig_
{
    double Fortz;
    double loadBal[NB_OA];
    double load[NB_OA];
    double sqLoad[NB_OA];
    double relLoad[NB_OA];
    double sqRelLoad[NB_OA];
    double delay[NB_OA];    
    double rerouting[NB_OA];
} PrimaryComputationConfig;

/**
 * High level configuration.
 * Predicates used when computing.
 */
typedef struct PredicateConfig_
{
    bool allowReroute; /**< accept preemptions of some lsps when computing */
    bool capacityClause; /**< no link capacity overtaking */
    bool colorClause; /**< take into account the color of the links */
} PredicateConfig;

typedef struct ReroutingConfig_
{
    double scoreCoef[NB_OA][NB_PREEMPTION];
} ReroutingConfig;

typedef struct DAMOTEConfig_
{
    PrimaryComputationConfig primaryComputationConfig;
    PredicateConfig predicateConfig;
    ReroutingConfig reroutingConfig;
} DAMOTEConfig;

extern DAMOTEConfig damoteConfig;

#endif
