#ifndef COMPUTATION_API_H
#define COMPUTATION_API_H

#include "common/common.h"
#include "error/error.h"
#include "computation_st.h"
#include "computation/primary/primaryPath_api.h"
#include "computation/backup/backup_api.h"


/*******************************************
 * Communication structures                *
 *******************************************/

// Label switched path Request representation:
//--------------------------------------------

LSPRequest* lspRequestNew();
int lspRequestInit(LSPRequest*);
int lspRequestDestroy(LSPRequest*);
int lspRequestEnd(LSPRequest*);
int lspRequestCopy(LSPRequest*,LSPRequest*);

// API for the LSPRequestList
// ---------------------------

int lspRequestListInit(LSPRequestList*, long);
int lspRequestListEnd(LSPRequestList*);
int lspRequestListResize(LSPRequestList*, long);
long lspRequestListsize(LSPRequestList*);
LSPRequest* lspRequestListGet(LSPRequestList*, long);
int lspRequestListSet(LSPRequestList*, LSPRequest*, long);


#endif
